#!/usr/bin/perl
use strict;
use List::MoreUtils qw(uniq);
##########################################################################################
# (1) quit unless we have the correct number of command-line args
my $num_args = $#ARGV + 1;

if ($num_args != 2) 
{
    print "\n Insufficient input files\n1: input Breed File \n2: Search Target file\n";
    exit;
}
my $query_file="";
$query_file=$ARGV[0];
my @temp=split /\./, $query_file;
my $query_filename=$temp[0];
my $search_file="";
$search_file=$ARGV[1];

my $res;
my $search_id="";
my @query_ltr=();
my @search_ltr=();
my @union=();
my @isect=();
my $query_line=""; 
my $search_line=""; 
open(QUERYFILE, "<$query_file") or die "Couldn't open file 1, $!";
open(SEARCHFILE, "<$search_file") or die "Couldn't open file 2, $!";
open(OUT,'>',$query_filename."_specific.vcf")  or die $!;
##########################################################################################
my $i=0;

while(($query_line=<QUERYFILE>) and ($search_line=<SEARCHFILE>))
{
	chomp($query_line);
	chomp($search_line);
		
	if($query_line =~/^#/)
	{
		print OUT $query_line."\n";
	}else{
		#print ($query_line."\n");
		#print ($search_line."\n");
		@query_ltr=split /\t/, $query_line;
		@search_ltr=split /\t/, $search_line;		
		my $chrom=$query_ltr[0];
		my $position=$query_ltr[1];
		my $ref_allele=$query_ltr[3];
		my $alt_allele=$query_ltr[4];
		my $no_of_query_cols= scalar(@query_ltr);
		my @query_genotypes=uniq(@query_ltr[9..$#query_ltr]);
		my @search_genotypes=uniq(@search_ltr[9..$#search_ltr]);
		#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		my @qr=();
		foreach (@query_genotypes) 
		{
			my @separated = split(':', $_);
			if($separated[0] ne "./.")
			{
				push @qr, $separated[0];
				#print $_."===>".$separated[0]."\t";
			}
		}
		#print scalar @qr."\n";
		#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		my @sr=();
		foreach (@search_genotypes) 
		{
			my @separated = split(':', $_);
			if($separated[0] ne "./.")
			{
				push @sr, $separated[0];
			}
		}		
		#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		#find the intersection between two arrays	
		my @intersection =
			grep { defined }
				@{ { map { lc ,=> $_ } @qr } }
				   { map { lc } @sr };

		my $no_of_common_genotypes= scalar @intersection;
		if($no_of_common_genotypes==0)
		{
			#my $output_line=$chrom."\t".$position."\t.\t".$ref_allele."\t".$alt_allele."\t.\t.\tPR\tGT\t\n";
			my $output_line=$query_line."\n";
			print OUT $output_line;
		}
				
	}
	

}

close(QUERYFILE) || die "Couldn't close file properly";
close(SEARCHFILE) || die "Couldn't close file properly";
close(OUT)